## START: Set by rpmautospec
## (rpmautospec version 0.3.0)
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global commit 8b8ead29fa515fd4fb04f35cbbfdce2459c58739
%global snapdate 20220919

Name:           lexertl14
Summary:        C++14 version of lexertl
Version:        0.1.0^%{snapdate}git%(echo '%{commit}' | cut -b -7)
Release:        %autorelease

License:        BSL-1.0
URL:            https://github.com/BenHanson/lexertl14
Source0:        %{url}/archive/%{commit}/lexertl14-%{commit}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  dos2unix

# No compiled binaries are installed, so this would be empty.
%global debug_package %{nil}

%global common_description %{expand:
lexertl is a header-only library for writing lexical analysers. With lexertl
you can:

  • Build lexical analysers at runtime
  • Scan Unicode and ASCII input
  • Scan from files or memory
  • Generate C++ code or even write your own code generator}

%description %{common_description}


%package devel
Summary:        %{summary}

# Header-only library:
Provides:       lexertl14-static = %{version}-%{release}

%description devel %{common_description}


%package examples
Summary:        Examples for lexertl14
BuildArch:      noarch

%description examples
%{summary}.


%prep
%autosetup -n lexertl14-%{commit}
# Adapt to multilib:
sed -r -i 's@(DESTINATION )lib\b@\1%{_libdir}@' CMakeLists.txt
# Fix line terminations (particularly for files that may be installed)
find . -type f -exec file '{}' '+' |
  grep -E '\bCRLF\b' |
  cut -d ':' -f 1 |
  xargs -r dos2unix


%build
%cmake -DBUILD_TESTING=on
%cmake_build


%install
%cmake_install


%check
%ctest


%files devel
%license include/lexertl/licence_1_0.txt
%doc README.md

%{_includedir}/lexertl/

%{_libdir}/cmake/lexertl/


%files examples
%license include/lexertl/licence_1_0.txt
%doc examples/*


%changelog
* Tue Dec 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220919git8b8ead2-2
- Indicate dirs. in files list with trailing slashes

* Tue Sep 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220919git8b8ead2-1
- Update to 8b8ead2 (Update to the latest Unicode standard)

* Fri Aug 05 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220228gitcd5a1f1-3
- Update License to SPDX

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.1.0^20220228gitcd5a1f1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Feb 28 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220228gitcd5a1f1-1
- Drop “forge” macros; adapt to current snapshot versioning guidelines

* Mon Feb 28 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-6
- Update to cd5a1f1 (Unicode 15)

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.1.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-4
- Update to 2ea71b8

* Tue Dec 14 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-3
- Dep. on cmake-filesystem is now auto-generated

* Fri Nov 19 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-2
- Update to commit 488602f

* Wed Aug 25 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-1
- Initial package
